Subject: Re: Apple Graphics Tablet
From: [email-masked] (Oliver Schmidt)
Date: Wed, 12 Jun 1996 08:25:43 GMT
Newsgroups: comp.sys.apple2

[email-masked] (John L. Graham) wrote:

>I had a similar question. I recently was given an Apple Graphics Tablet in
>_mint_ condition. Interface card and everything, but no software. Does anyone
>know how to write programs which can use it? I looked in our library of Apple
>tech notes but came up empty.

Hi,

first, let's make sure we're talking about the same thing: the Apple
Graphics Tablet I know of is rather large and heavy; its pen is
attached to it with a (too short) cable; it makes funny sounds that
change when the pen is moved in/out the reach of of the tablet.

A long time ago I patched a few programs to make use of this tablet.
To make it clear in the first place - I don't have theese patched
versions available anymore :-(. But I found a listing from which I can
tell You this:

To detect to interface card, I looped over all slots to check in its
firmware for

$B0 at location $Cx01 and

$20 at location $Cx09

beeing x the slot number. I never found this 'signature' in any other
firmware.

To check for the pen position one has to poll the tablet (again beeing
x the slot number):

LDA $CFFF ; switch off all extension ROMS

LDA $Cx00 ; switch on the extension ROM of the tablet

LDA #$Cx
STA $07F8 ; initialize some hidden text screen data area for the
tablet firmware

JSR $CBB9 ; call well known location ;-) in tablet firmware

When the pen is in reach of the tablet (up or down) this routine will
return immediatly. Else it will block - fortunatly the routine checks
the keyboard strobe ($C010) too and will also return if a key is
pressed, even if the pen remains out of tablets reach.

After the routine has returned one can get the information:

$0280 contains the state of the pen (up or down), I don't know excatly
any more wich bit it is nor if one can distiguish between 'pen up' and
'pen out of reach but key pressed'

$0281, $0282 contains the absolute X position of the pen

$0283, $0284 contains the absolute Y position of the pen

As far as I can remember the values have about 12 bit resolution (!).
Usually I needed screen coordinates (280 x 192), so I dropped the 4
least significant bits and did some additional adjustment.
Unfortunatly I can't remember either what coordinates will be there in
the 'out of reach but key pressed' case.

Hope this helps a little - if somebody has success using this method,
please give me some feedback.

BTW: I'm working on an Apple ][+ emulator, but suffer from a total
lack of infos about the Apple ][ mouse (I think it goes into slot 4
and uses some interrupt stuff ???) due to the fact that I have never
even seen such a mouse. Any way I'd like to build support for it into
my emulator. So what ports - what firmware - ... thanks for help in
advance.

Oliver

EOF